#
# Conditional build:
%bcond_without	python2	# CPython 2.x module
%bcond_without	python3	# CPython 3.x module
%bcond_without	tests	# pytest tests
%bcond_without	doc	# Sphinx documentation

Summary:	The modular source code checker: pycodestyle, pyflakes and co
Summary(pl.UTF-8):	Modularne narzędzie do sprawdzania kodu źródłowego: pycodestyle, pyflakes itp.
Name:		flake8
Version:	3.5.0
Release:	1
License:	MIT
Group:		Development/Tools
#Source0Download: https://pypi.org/simple/flake8/
Source0:	https://files.pythonhosted.org/packages/source/f/flake8/%{name}-%{version}.tar.gz
# Source0-md5:	7e5fe39d578a2c2d0962b61b35b8c3fc
Patch0:		%{name}-mock.patch
URL:		https://gitlab.com/pycqa/flake8
BuildRequires:	rpmbuild(macros) >= 1.714
BuildRequires:	rpm-pythonprov
%if %{with python2}
BuildRequires:	python-modules >= 1:2.7
BuildRequires:	python-setuptools >= 30
%if %{with tests}
BuildRequires:	python-configparser
BuildRequires:	python-enum34
BuildRequires:	python-mccabe >= 0.6.0
BuildRequires:	python-mccabe < 0.7.0
BuildRequires:	python-mock >= 2.0.0
BuildRequires:	python-pycodestyle >= 2.0.0
BuildRequires:	python-pycodestyle < 2.4.0
BuildRequires:	python-pyflakes >= 1.5.0
BuildRequires:	python-pyflakes < 1.7.0
BuildRequires:	python-pytest
BuildRequires:	python-pytest-runner
%endif
%endif
%if %{with python3}
BuildRequires:	python3-modules >= 1:3.4
BuildRequires:	python3-setuptools >= 30
%if %{with tests}
BuildRequires:	python3-mccabe >= 0.6.0
BuildRequires:	python3-mccabe < 0.7.0
BuildRequires:	python3-pycodestyle >= 2.0.0
BuildRequires:	python3-pycodestyle < 2.4.0
BuildRequires:	python3-pyflakes >= 1.5.0
BuildRequires:	python3-pyflakes < 1.7.0
BuildRequires:	python3-pytest
BuildRequires:	python3-pytest-runner
BuildRequires:	sed >= 4.0
%endif
%endif
%if %{with doc}
BuildRequires:	python3-sphinx-prompt
BuildRequires:	sphinx-pdg-3
%endif
%if %{with python3}
Requires:	python3-flake8 = %{version}-%{release}
%else
Requires:	python-flake8 = %{version}-%{release}
%endif
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The modular source code checker. It is a wrapper around these tools:
- PyFlakes
- pycodestyle
- Ned Batchelder's McCabe script

%description -l pl.UTF-8
Modularne narzędzie do sprawdzania kodu źródłowego. Jest to opakowanie
dla narzędzi:
- PyFlakes
- pycodestyle
- skrypt McCabe autorstwa Neda Batcheldera

%package -n python-flake8
Summary:	The modular source code checker: pycodestyle, pyflakes and co
Summary(pl.UTF-8):	Modularne narzędzie do sprawdzania kodu źródłowego: pycodestyle, pyflakes itp.
Group:		Libraries/Python
Requires:	python-modules >= 1:2.7

%description -n python-flake8
The modular source code checker. It is a wrapper around these tools:
- PyFlakes
- pycodestyle
- Ned Batchelder's McCabe script

%description -n python-flake8 -l pl.UTF-8
Modularne narzędzie do sprawdzania kodu źródłowego. Jest to opakowanie
dla narzędzi:
- PyFlakes
- pycodestyle
- skrypt McCabe autorstwa Neda Batcheldera

%package -n python3-flake8
Summary:	The modular source code checker: pycodestyle, pyflakes and co
Summary(pl.UTF-8):	Modularne narzędzie do sprawdzania kodu źródłowego: pycodestyle, pyflakes itp.
Group:		Libraries/Python
Requires:	python3-modules >= 1:3.4

%description -n python3-flake8
The modular source code checker. It is a wrapper around these tools:
- PyFlakes
- pycodestyle
- Ned Batchelder's McCabe script

%description -n python3-flake8 -l pl.UTF-8
Modularne narzędzie do sprawdzania kodu źródłowego. Jest to opakowanie
dla narzędzi:
- PyFlakes
- pycodestyle
- skrypt McCabe autorstwa Neda Batcheldera

%package -n python-flake8-apidocs
Summary:	API documentation for Python flake8 module
Summary(pl.UTF-8):	Dokumentacja API modułu Pythona flake8
Group:		Documentation

%description -n python-flake8-apidocs
API documentation for Python flake8 module.

%description -n python-flake8-apidocs -l pl.UTF-8
Dokumentacja API modułu Pythona flake8.

%prep
%setup -q
%patch0 -p1

%build
%if %{with python2}
%py_build %{?with_tests:test}
%endif

%if %{with python3}
# don't require standalone mock
%{__sed} -i -e 's/import mock/from unittest import mock/' $(grep 'import mock' tests/ -rl)

%py3_build %{?with_tests:test}
%endif

%if %{with doc}
cd docs/source
PYTHONPATH=$(pwd)/../../src \
sphinx-build-3 -b html . _build/html
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%py_install
%{__mv} $RPM_BUILD_ROOT%{_bindir}/flake8{,-2}
%py_postclean
%endif

%if %{with python3}
%py3_install
%{__mv} $RPM_BUILD_ROOT%{_bindir}/flake8{,-3}

# avoid dependencies on python3egg(configparser), python3egg(enum34)
%{__sed} -i -e "/^\[:python_version *< *'3\.2']/,/^$/ d" \
	-e "/^\[:python_version *< *'3\.4']/,/^$/ d" \
	$RPM_BUILD_ROOT%{py3_sitescriptdir}/flake8-%{version}-py*.egg-info/requires.txt
%endif

ln -s flake-%{!?with_python3:2}%{?with_python3:3} $RPM_BUILD_ROOT%{_bindir}/flake8

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/flake8

%if %{with python2}
%files -n python-flake8
%defattr(644,root,root,755)
%doc CONTRIBUTORS.txt LICENSE README.rst
%attr(755,root,root) %{_bindir}/flake8-2
%{py_sitescriptdir}/flake8
%{py_sitescriptdir}/flake8-%{version}-py*.egg-info
%endif

%if %{with python3}
%files -n python3-flake8
%defattr(644,root,root,755)
%doc CONTRIBUTORS.txt LICENSE README.rst
%attr(755,root,root) %{_bindir}/flake8-3
%{py3_sitescriptdir}/flake8
%{py3_sitescriptdir}/flake8-%{version}-py*.egg-info
%endif

%if %{with doc}
%files -n python-flake8-apidocs
%defattr(644,root,root,755)
%doc docs/source/_build/html/{_modules,_static,internal,plugin-development,release-notes,user,*.html,*.js}
%endif
%changelog
* Sun Jul 22 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/flake8.git;a=log;h=master

* Sun Jul 22 2018 Jakub Bogusz <qboosh@pld-linux.org> 34073ed
- updated to 3.5.0
- added -apidocs

* Sun Jul 01 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 975a3e6
- release 3 (by relup.sh)

* Mon Apr 17 2017 Jakub Bogusz <qboosh@pld-linux.org> d7cb1eb
- updated descriptions and dependencies
- added mock patch and sed substitution (use unittest.mock under python3)

* Sat Apr 15 2017 Jan Rękorajski <baggins@pld-linux.org> 972dfbb
- typo

* Sat Apr 15 2017 Jan Rękorajski <baggins@pld-linux.org> 5312367
- updated BRs
- rel 2

* Sat Apr 15 2017 Jan Rękorajski <baggins@pld-linux.org> 7db5e8a
- removed obsolete patch

* Sat Apr 15 2017 Jan Rękorajski <baggins@pld-linux.org> 9bc90c2
- up to 3.3.0
- updated BRs

* Thu Dec 29 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 3643ee8
- python 3.6
- release 2 (by relup.sh)

* Fri Mar 25 2016 Jakub Bogusz <qboosh@pld-linux.org> 19c415b
- added dependencies patch (bump maximum pyflakes version)

* Mon Mar 21 2016 Elan Ruusamäe <glen@delfi.ee> 8b0b670
- use symlink

* Mon Mar 21 2016 Jakub Bogusz <qboosh@pld-linux.org> 37b9d23
- updated to 2.5.4
- added python-/python3- packages

* Sun Nov 29 2015 Jacek Konieczny <jajcus@jajcus.net> ee25eca
- BR: rpmbuild(macros) >= 1.710

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 33643bb
- automatic change: use py_build/py_install macros

* Mon Sep 14 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> b6e3cac
- python 3.5 rebuild
- release 2 (by relup.sh)

* Fri Nov 28 2014 Elan Ruusamäe <glen@delfi.ee> 15a03bb
- update BR

* Thu Nov 27 2014 Elan Ruusamäe <glen@delfi.ee> a24e9a3
- enable tests (tests bcond did not exist), update deps for tests

* Thu Nov 27 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> abcf879
- initial

